// pages/product_category/product_category.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    navigationBarAndStatusBarHeight: (app.globalData.navigationBarAndStatusBarHeight + 65) + 'px',
    product_category: [],
    product_list: [],
    cat_id: '',
    brand_id: '',
    page: 1, // 初始页默认值为1
    nomore: false,
    treeHeight: 500
  },
 
  onLoad: function(options) {
    var that = this
        
    that.setData({
      title: app.title.product
    })
    
    // 显示转发按钮
    dou.showShareMenu()
   
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    if (options.cat_id) {
      that.setData({
        cat_id: options.cat_id
      })
    }
    if (options.brand_id) {
      that.setData({
        brand_id: options.brand_id
      })
    }
    that.getTreeHeight()
    that.loadData()
  },
 
  onShow: function () {
    var that = this;
   
    if (wx.getStorageSync('product_category_id')) {
      that.setData({
        cat_id: wx.getStorageSync('product_category_id')
      })
      that.loadData()
    }
    
    // 在tabBar第三个图标中显示购物车数量
    dou.showCartNumber()
  },

  // 获取数据
  loadData: function(concat = false, page = '') {
    var that = this;
    var cat_id = that.data.cat_id;
    var brand_id = that.data.brand_id;
    
    wx.request({
      url: app.mp_url + 'product_category.php',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        cat_id: cat_id,
        brand_id: brand_id,
        page: page ? page : that.data.page, // 从数据里获取当前页数
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        // 设置转发标题缓存
        wx.setStorageSync('shareTitle', res.data.title)
        
        if (concat) {
          var dataBox = that.data.product_list; // 从data获取当前datalist数组
          var dataNew = res.data.product_list; // 从此次请求返回的数据中获取新数组
          
          if (dataNew) {
            dataBox = dataBox.concat(dataNew); // 合并数组
          } else {
            that.setData({
              nomore: true
            })
          }
        } else {
          dataBox = res.data.product_list;
        }
        
        that.setData({
          product_list: dataBox,
          product_category: res.data.product_category,
          cate_info: res.data.cate_info,
          cat_id: res.data.cat_id,
          loadpage: false
        })
      },
    })
  },
 
  onReachBottom: function() { // 触底开始下一页
    var that = this;
    
    if (!that.data.nomore) {
      var page = that.data.page + 1; // 获取当前页数并+1
    
      that.setData({
        page: page, // 更新当前页数
        loadpage: true,//加载动画的显示
      })

      setTimeout (
        function() { //注意function这里不能缺少
          that.loadData(true); // 重新调用请求获取下一页数据
        },1000
      )
    }
  },

  // 传入参数重新加载
  douMenu: function(e) {
    wx.removeStorage({key: 'product_category_id'})
    this.setData({
      cat_id: e.currentTarget.dataset.catid,
      page: 1,
      nomore: false
    })
    this.loadData()
  },

  // 计算左边菜单高度
  getTreeHeight: function() {
    var windowHeight = wx.getWindowInfo().windowHeight;
    var query = wx.createSelectorQuery();
   
    query.select('.page-top').boundingClientRect(rect=>{
      this.setData({
        treeHeight: windowHeight - rect.height
      })
    }).exec();
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})